find_path(FFMPEG_INCLUDE_DIR libavcodec/version.h)
find_library(FFMPEG_AVCODEC NAMES avcodec)
find_library(FFMPEG_AVFORMAT NAMES avformat)
find_library(FFMPEG_AVUTIL NAMES avutil)
find_library(FFMPEG_SWRESAMPLE NAMES swresample)
find_library(FFMPEG_SWSCALE NAMES swscale)


include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(FFmpeg
    FOUND_VAR FFmpeg_FOUND
    REQUIRED_VARS
        FFMPEG_INCLUDE_DIR
        FFMPEG_AVCODEC
        FFMPEG_AVFORMAT
        FFMPEG_AVUTIL
        FFMPEG_SWRESAMPLE
        FFMPEG_SWSCALE
)

add_library(FFmpeg::avcodec SHARED IMPORTED)
set_target_properties(FFmpeg::avcodec
    PROPERTIES
        INTERFACE_INCLUDE_DIRECTORIES ${FFMPEG_INCLUDE_DIR}
        INTERFACE_LINK_LIBRARIES ${FFMPEG_AVCODEC}
        IMPORTED_LOCATION ${FFMPEG_AVCODEC}
)

add_library(FFmpeg::avformat SHARED IMPORTED)
set_target_properties(FFmpeg::avformat
    PROPERTIES
        INTERFACE_INCLUDE_DIRECTORIES ${FFMPEG_INCLUDE_DIR}
        INTERFACE_LINK_LIBRARIES ${FFMPEG_AVFORMAT}
        IMPORTED_LOCATION ${FFMPEG_AVFORMAT}
)

add_library(FFmpeg::avutil SHARED IMPORTED)
set_target_properties(FFmpeg::avutil
    PROPERTIES
        INTERFACE_INCLUDE_DIRECTORIES ${FFMPEG_INCLUDE_DIR}
        INTERFACE_LINK_LIBRARIES ${FFMPEG_AVUTIL}
        IMPORTED_LOCATION ${FFMPEG_AVUTIL}
)


add_library(FFmpeg::swresample SHARED IMPORTED)
set_target_properties(FFmpeg::swresample
    PROPERTIES
        INTERFACE_INCLUDE_DIRECTORIES ${FFMPEG_INCLUDE_DIR}
        INTERFACE_LINK_LIBRARIES ${FFMPEG_SWRESAMPLE}
        IMPORTED_LOCATION ${FFMPEG_SWRESAMPLE}
)

add_library(FFmpeg::swscale SHARED IMPORTED)
set_target_properties(FFmpeg::swscale
    PROPERTIES
        INTERFACE_INCLUDE_DIRECTORIES ${FFMPEG_INCLUDE_DIR}
        INTERFACE_LINK_LIBRARIES ${FFMPEG_SWSCALE}
        IMPORTED_LOCATION ${FFMPEG_SWSCALE}
)


mark_as_advanced(
    FFMPEG_INCLUDE_DIR
    FFMPEG_AVCODEC
    FFMPEG_AVFORMAT
    FFMPEG_AVUTIL
    FFMPEG_SWRESAMPLE
    FFMPEG_SWSCALE
)