#include "mov64Common.h"


int mov64_av_encode(AVCodecContext* avctx, AVPacket* pkt, const AVFrame* frame, int* got_packet) {
  int ret;

  *got_packet = 0;

  if (pkt) {
    ret = avcodec_send_frame(avctx, frame);
    if (ret < 0) {
      return ret == AVERROR_EOF ? 0 : ret;
    }
  }

  ret = avcodec_receive_packet(avctx, pkt);

  if (ret == AVERROR(EAGAIN) || ret == AVERROR_EOF) {
    return 0;
  }

  if (ret < 0) {
    return ret;
  }

  if (!ret) {
    *got_packet = 1;
  }

  return 0;
}

int mov64_av_decode(AVCodecContext* avctx, AVFrame* frame, int* got_frame, const AVPacket & pkt) {
  int ret;

  *got_frame = 0;

  ret = avcodec_send_packet(avctx, &pkt);
  if (ret < 0) {
    return ret == AVERROR_EOF ? 0 : ret;
  }

  ret = avcodec_receive_frame(avctx, frame);

  if (ret < 0 && ret != AVERROR(EAGAIN) && ret != AVERROR_EOF) {
    return ret;
  }

  if (ret >= 0) {
    *got_frame = 1;
  }

  return 0;
}

