// Copyright (c) 2014 The Foundry Visionmongers Ltd.  All Rights Reserved.
#ifndef NUKE_MOVREADER_FORMAT_H
#define NUKE_MOVREADER_FORMAT_H


#include "DDImage/Reader.h"

const char* const kDecoderLabels[3] =
{
  "mov64",
  "mov32",
  nullptr,
};

enum {
  kDecoderMov64,
  kDecoderMov32
};


///////////////////////////////////////////////////////////////////////////////////////////////
class mov64ReaderFormat;
class mov32ReaderFormat;

// Proxy class for mov32 and mov64 reader formats
class movReaderFormat : public DD::Image::ReaderFormat
{
public:
  movReaderFormat( DD::Image::Read* iop )
  : _iop( iop )
  , _mov64ReaderFormat(nullptr)
  , _mov32ReaderFormat(nullptr)
  , _decoder(kDecoderMov64) { }

  int getDecoder() const { return _decoder; }
  mov64ReaderFormat* getMov64ReaderFormat() { return _mov64ReaderFormat; }
  mov32ReaderFormat* getMov32ReaderFormat() { return _mov32ReaderFormat; }

protected:
  DD::Image::Read* _iop;
  mov64ReaderFormat* _mov64ReaderFormat;
  mov32ReaderFormat* _mov32ReaderFormat;

  int _decoder;
};

#endif
